###################################################################################################################################################
# Copyright 2015 Orchid Systems 
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################


#################### Import Modules ###########################################
from accpac import *

import time
import datetime
import subprocess

###############################################################################

oedtl = None
arcusto = None
bInvalid = Continue

def onOpen():
	if rotoID != "OE0520":
		return 0	# don't do anything since the view is not OE0500 O/E sales order details.

	if program != "OE1100":
		return 0	# don't do anything since this is not called from the O/E Sales Order Entry screen.

	# Check system access to prevent running the script during Data Integrity Check, Import, Export, etc:
	if int(me.getAccess()) != 0:
		return 0.# do not run the script. System Access is not Normal.
		
	return Continue

def onBeforeCompose(e):
	global oedtl
	if e.views[0] is None:
		oedtl = None
	else:
		oedtl = e.views[0]

	return Continue

def onBeforeInsert():
	rvspyTrace("onBeforeInsert")

	global oedtl

	if oedtl is not None:
		# Validate against duplicate items.
		return verifyDetailLines()

	return Continue


def onBeforeUpdate():
	rvspyTrace("onBeforeUpdate")

	global oedtl

	if oedtl is not None:
		# Validate against duplicate items.
		return verifyDetailLines()

	return Continue


def verifyDetailLines():
	global oedtl

	itemList = []
	itemList2 = []

	oedtl.recordClear()
	oedtl.browse("LINETYPE = 1",1)
	res = oedtl.fetch()
	while res == 0:
		sItem = oedtl.get("ITEM")
		sItem = sItem.strip()
		
		# add to item list.
		itemList.append(sItem)
		itemList2.append(sItem)

		res = oedtl.fetch()

	if len(itemList) > 0:
		# check how many times an item appears in the list.
		rvspyTrace("")
		for sItem in itemList:
			itemCnt = itemList2.count(sItem)

			if itemCnt > 1:
				showMessage("Item [" + sItem + "] has been found entered " + str(itemCnt) + " x times into this order.")
				for sItem in itemList:
					itemList.remove(sItem)


	return Continue

